<template>
  <v-app>
    <navigation-drawer />
    <!--    <list-navigation-menu></list-navigation-menu>-->
    <vue-header />
    <Component :is="$route.meta.layoutComponent" />
  </v-app>
  <!--  <div class="background">-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--    <span></span>-->
  <!--  </div>-->
</template>

<script setup>
import { watch, nextTick } from 'vue'
import NavigationDrawer from '@/components/common/drawers/NavigationDrawer.vue'
import VueHeader from '@/components/common/header/AppHeader.vue'
import { useTheme } from 'vuetify'
import ListNavigationMenu from '@/components/common/drawers/ListNavigationMenu.vue'
const theme = useTheme()
watch(theme.global.name, themeTransition)
function themeTransition() {
  // const x = performance.now()
  // for (let i = 0; i++ < 1e7; (i << 9) & ((9 % 9) * 9 + 9));
  // if (performance.now() - x > 0) return

  const el = document.querySelector('[data-v-app]')

  const copy = el.cloneNode(true)
  copy.classList.add('app-copy')
  const rect = el.getBoundingClientRect()
  copy.style.top = rect.top + 'px'
  copy.style.left = rect.left + 'px'
  copy.style.width = rect.width + 'px'
  copy.style.height = rect.height + 'px'

  const targetEl = document.activeElement
  const targetRect = targetEl.getBoundingClientRect()
  const left = targetRect.left + targetRect.width / 2 + window.scrollX
  const top = targetRect.top + targetRect.height / 2 + window.scrollY
  el.style.setProperty('--clip-pos', `${left}px ${top}px`)
  el.style.removeProperty('--clip-size')

  nextTick(() => {
    console.log('nextTick')
    el.classList.add('app-transition')
    requestAnimationFrame(() => {
      requestAnimationFrame(() => {
        el.style.setProperty(
          '--clip-size',
          Math.hypot(window.innerWidth, window.innerHeight) + 'px'
        )
      })
    })
  })

  document.body.append(copy)

  Array.from(copy.querySelectorAll('[data-scroll-x], [data-scroll-y]')).forEach(
    el => {
      el.scrollLeft = +el.dataset.scrollX
      el.scrollTop = +el.dataset.scrollY
    }
  )

  function onTransitionend(e) {
    if (e.target === e.currentTarget) {
      copy.remove()
      el.removeEventListener('transitionend', onTransitionend)
      el.removeEventListener('transitioncancel', onTransitionend)
      el.classList.remove('app-transition')
      el.style.removeProperty('--clip-size')
      el.style.removeProperty('--clip-pos')
    }
  }
  el.addEventListener('transitionend', onTransitionend)
  el.addEventListener('transitioncancel', onTransitionend)
}
</script>
<style>
.app-copy {
  position: fixed !important;
  z-index: -1 !important;
  pointer-events: none !important;
  contain: size style !important;
  overflow: clip !important;
}

.app-transition {
  --clip-size: 0;
  --clip-pos: 0 0;
  clip-path: circle(var(--clip-size) at var(--clip-pos));
  transition: clip-path 0.4s ease-out;
}
/*body {*/
/*  margin: 0;*/
/*  overflow: hidden;*/
/*}*/

/*.background {*/
/*  width: 100vw;*/
/*  height: 100vh;*/
/*  background: transparent;*/
/*}*/

/*.background span {*/
/*  z-index: -1;*/
/*  opacity: 0.3;*/
/*  width: 20vmin;*/
/*  height: 20vmin;*/
/*  border-radius: 20vmin;*/
/*  backface-visibility: hidden;*/
/*  position: absolute;*/
/*  animation-name: move;*/
/*  animation-duration: 6s;*/
/*  animation-timing-function: linear;*/
/*  animation-iteration-count: infinite;*/
/*}*/
/*.background span:nth-child(1) {*/
/*  color: #0f47af;*/
/*  top: 13%;*/
/*  left: 22%;*/
/*  animation-duration: 13.6s;*/
/*  animation-delay: -1.6s;*/
/*  transform-origin: 10vw 13vh;*/
/*  box-shadow: 40vmin 0 12.7139468577vmin currentColor;*/
/*}*/
/*.background span:nth-child(2) {*/
/*  color: #44a51c;*/
/*  top: 18%;*/
/*  left: 54%;*/
/*  animation-duration: 12.9s;*/
/*  animation-delay: -12.7s;*/
/*  transform-origin: -13vw 10vh;*/
/*  box-shadow: 40vmin 0 12.605763933vmin currentColor;*/
/*}*/
/*.background span:nth-child(3) {*/
/*  color: #0f47af;*/
/*  top: 5%;*/
/*  left: 26%;*/
/*  animation-duration: 14.1s;*/
/*  animation-delay: -13.1s;*/
/*  transform-origin: 3vw -12vh;*/
/*  box-shadow: -40vmin 0 14.6261041065vmin currentColor;*/
/*}*/
/*.background span:nth-child(4) {*/
/*  color: #44a51c;*/
/*  top: 49%;*/
/*  left: 4%;*/
/*  animation-duration: 13.6s;*/
/*  animation-delay: -15.5s;*/
/*  transform-origin: -23vw 8vh;*/
/*  box-shadow: -40vmin 0 8.6034679391vmin currentColor;*/
/*}*/
/*.background span:nth-child(5) {*/
/*  color: #0f47af;*/
/*  top: 43%;*/
/*  left: 6%;*/
/*  animation-duration: 12.3s;*/
/*  animation-delay: -8.3s;*/
/*  transform-origin: 15vw 4vh;*/
/*  box-shadow: -40vmin 0 12.5974448469vmin currentColor;*/
/*}*/
/*.background span:nth-child(6) {*/
/*  color: #0f47af;*/
/*  top: 54%;*/
/*  left: 85%;*/
/*  animation-duration: 15.8s;*/
/*  animation-delay: -12.5s;*/
/*  transform-origin: 15vw -23vh;*/
/*  box-shadow: -40vmin 0 11.3655118599vmin currentColor;*/
/*}*/
/*.background span:nth-child(7) {*/
/*  color: #0f47af;*/
/*  top: 74%;*/
/*  left: 60%;*/
/*  animation-duration: 12.3s;*/
/*  animation-delay: -4.7s;*/
/*  transform-origin: -23vw 0vh;*/
/*  box-shadow: 40vmin 0 8.3817917822vmin currentColor;*/
/*}*/
/*.background span:nth-child(8) {*/
/*  color: #0f47af;*/
/*  top: 94%;*/
/*  left: 52%;*/
/*  animation-duration: 14.1s;*/
/*  animation-delay: -9.1s;*/
/*  transform-origin: 12vw 5vh;*/
/*  box-shadow: -40vmin 0 14.2077822681vmin currentColor;*/
/*}*/
/*.background span:nth-child(9) {*/
/*  color: #0f47af;*/
/*  top: 30%;*/
/*  left: 16%;*/
/*  animation-duration: 15.5s;*/
/*  animation-delay: -12.1s;*/
/*  transform-origin: -8vw 7vh;*/
/*  box-shadow: -40vmin 0 9.7067114568vmin currentColor;*/
/*}*/
/*.background span:nth-child(10) {*/
/*  color: #ffffff;*/
/*  top: 73%;*/
/*  left: 4%;*/
/*  animation-duration: 10.5s;*/
/*  animation-delay: -0.4s;*/
/*  transform-origin: -20vw -11vh;*/
/*  box-shadow: 40vmin 0 14.8703892738vmin currentColor;*/
/*}*/
/*.background span:nth-child(11) {*/
/*  color: #ffffff;*/
/*  top: 19%;*/
/*  left: 14%;*/
/*  animation-duration: 10.1s;*/
/*  animation-delay: -3.1s;*/
/*  transform-origin: 3vw 7vh;*/
/*  box-shadow: -40vmin 0 9.6719782374vmin currentColor;*/
/*}*/
/*.background span:nth-child(12) {*/
/*  color: #44a51c;*/
/*  top: 24%;*/
/*  left: 14%;*/
/*  animation-duration: 14.8s;*/
/*  animation-delay: -7.6s;*/
/*  transform-origin: 13vw -16vh;*/
/*  box-shadow: -40vmin 0 8.6670954467vmin currentColor;*/
/*}*/
/*.background span:nth-child(13) {*/
/*  color: #ffffff;*/
/*  top: 33%;*/
/*  left: 75%;*/
/*  animation-duration: 11.7s;*/
/*  animation-delay: -7.1s;*/
/*  transform-origin: -1vw -23vh;*/
/*  box-shadow: -40vmin 0 14.612137579vmin currentColor;*/
/*}*/
/*.background span:nth-child(14) {*/
/*  color: #0f47af;*/
/*  top: 76%;*/
/*  left: 28%;*/
/*  animation-duration: 15.1s;*/
/*  animation-delay: -5.2s;*/
/*  transform-origin: -2vw -13vh;*/
/*  box-shadow: 40vmin 0 5.0890477955vmin currentColor;*/
/*}*/
/*.background span:nth-child(15) {*/
/*  color: #44a51c;*/
/*  top: 27%;*/
/*  left: 31%;*/
/*  animation-duration: 11.2s;*/
/*  animation-delay: -5.9s;*/
/*  transform-origin: -22vw -3vh;*/
/*  box-shadow: -40vmin 0 9.641029877vmin currentColor;*/
/*}*/
/*.background span:nth-child(16) {*/
/*  color: #ffffff;*/
/*  top: 15%;*/
/*  left: 54%;*/
/*  animation-duration: 15.1s;*/
/*  animation-delay: -9.5s;*/
/*  transform-origin: -4vw 0vh;*/
/*  box-shadow: -40vmin 0 14.6958220232vmin currentColor;*/
/*}*/
/*.background span:nth-child(17) {*/
/*  color: #ffffff;*/
/*  top: 75%;*/
/*  left: 4%;*/
/*  animation-duration: 12.4s;*/
/*  animation-delay: -13.8s;*/
/*  transform-origin: -10vw -8vh;*/
/*  box-shadow: 40vmin 0 14.4938385341vmin currentColor;*/
/*}*/
/*.background span:nth-child(18) {*/
/*  color: #0f47af;*/
/*  top: 98%;*/
/*  left: 59%;*/
/*  animation-duration: 12.3s;*/
/*  animation-delay: -0.5s;*/
/*  transform-origin: 14vw 7vh;*/
/*  box-shadow: 40vmin 0 9.3529334293vmin currentColor;*/
/*}*/
/*.background span:nth-child(19) {*/
/*  color: #0f47af;*/
/*  top: 23%;*/
/*  left: 88%;*/
/*  animation-duration: 11.7s;*/
/*  animation-delay: -8.7s;*/
/*  transform-origin: -10vw -8vh;*/
/*  box-shadow: -40vmin 0 7.1858397093vmin currentColor;*/
/*}*/
/*.background span:nth-child(20) {*/
/*  color: #ffffff;*/
/*  top: 37%;*/
/*  left: 57%;*/
/*  animation-duration: 15.4s;*/
/*  animation-delay: -13.6s;*/
/*  transform-origin: -18vw -4vh;*/
/*  box-shadow: 40vmin 0 5.7790032868vmin currentColor;*/
/*}*/

/*@keyframes move {*/
/*  100% {*/
/*    transform: translate3d(0, 0, 1px) rotate(360deg);*/
/*  }*/
/*}*/
</style>
